#include <puppy.h>
#include <pupmem.h>
#include <ascii.h>

/* 
	This is the main control loop for Puppys FidoNet. 
*/

fidonet(event)
int event;			/* event number to run */
{
int index;			/* funny index into the topic map */
int interval;			/* outgoing call interval, seconds */
int mapsize;			/* total number of topic map entries */

FLAG rdymsg;

	mapsize= opentm();				/* start the topic map */
	interval= 60;					/* call every 60 sec */
	index= 0;
	rdymsg= 0;

	clr_clk();					/* reset the clock, */
	while (til_event(event)) {
		switch (keyhit()) {			/* poll the keyboard */
			case '?':
				printf("^C     Return to DOS\r\n");
				printf("\"L\"    List activity\r\n");
				printf("\"C\"    Immediate Call (if any)\r\n");
				rdymsg= 0;
				break;

			case 'l':
			case 'L': dsp_map(mapsize); rdymsg= 0; break;

			case 'c': 
			case 'C': interval= 0; break;
				
			case ETX: doscode= 1; break;
		}
		if (doscode) break;

		if (answer() > 0) {			/* incoming call */
			rcv_mail();			/* get mail */
			seconds= interval;		/* immediate outgoing */
			continue;
		}

		if (! rdymsg) printf("Pup says: \"FidoNet active (?=help) (?=help)\"\r\n");
		rdymsg= 1;

		if (seconds < interval) continue;	/* not time yet */
		if (answer()) continue;			/* modem is busy */

		index= next_node(index,mapsize);	/* choose node to call */
		if (index != -1) send_mail(index);	/* send it */
		clr_clk();				/* start waiting */
		rdymsg= 0;
	}
	dsp_map(mapsize);				/* display the map */
	closetm();					/* close the topic map */
}

/* Display the topic map. */

dsp_map(mapsize)
int mapsize;
{
int n,i;
struct _tm tm;

	for (i= 0; i < mapsize; i++) {
		gettm(&tm,i);
		printf("%16s ",str_node(&tm.node));
		for (n= 0; n < 16; n++) {
			if (tm.topic & (1 << n)) printf("%d ",n);
		}
		printf("Updated: %s%s  ",str_date(tm.date),str_time(tm.time));
		printf("Tries:%d Connects:%d\r\n",tm.tries,tm.connects);
	}
}

/* Choose the next node to call ahead of time, return its index or -1 if
none to call. */

next_node(index,mapsize)
int index,mapsize;
{
int i;
struct _tm tm;

	for (i= mapsize; --i; ) {			/* one pass through */
		index += traverse(mapsize);		/* choose next ... */
		index %= mapsize;			/* ... */
		gettm(&tm,index);			/* load map entry */

		if (tm.tries > pup.tries) continue;	/* too many tries? */
		if (tm.connects > pup.connects) continue;/* too many connects? */
		if (tm.bits & TM_HOLD) continue;	/* hold for pickup? */

		if (mailfor(&tm)) return(index);	/* if this one has mail */
	}
	return(-1);					/* no more to do */
}

/* Calculate the traversal index such that we go through the table
of nodes non-sequentially. This keeps us from calling nodes in 
topic_map order, which would means nodes towards the end wouldnt get
called as often as ones in the beginning of the list. */

static BYTE primes[] = {227,167,149,131,113,101,83,37,23,19,17,13,11,7,5,3,2,0};

traverse(n)
int n;
{
int i;
BYTE *p;

	p= primes;
	while (*p) {				/* less than N and not a factor */
		if ((*p < n) && (n % *p)) return(*p);
		++p;
	}
	return(1);				/* oh well */
}

/* Parse a string into net and node number. zone and net are untouched if
not found in the input string. This parses as follows: (xx means unchanged)

string			output

99:88/77		99:88/77
88/77			xx:88/88
77			xx:xx/77
99:88			99:88/00
88/			xx:88/00

*/

set_nn(cp,n)
char *cp;
struct _node *n;
{
int x;

	n-> number= atoi(cp);			/* assume its node only */
	while (isdigit(*cp)) ++cp;		/* skip the number, */

	if (*cp == ':') {			/* if it was a zone, */
		n-> zone= n-> number;		/* that was a zone number, */
		n-> net= atoi(++cp);		/* net must follow */
		while (isdigit(*cp)) ++cp;	/* skip the net number */
		if (*cp == '/')			/* if that was a net number */
			n-> number= atoi(++cp);	/* set node number (or zero) */

	} else if (*cp == '/') {		/* if that was a net number, */
		n-> net= n-> number;		/* copy it up, */
		n-> number= atoi(++cp);		/* now set node number */
	}
}
